Scriptname RomanThrowScript extends ReferenceAlias  

import game
import utility

FormList Property JThrowingWeaponList  Auto 
FormList Property JThrowingWeaponSpell  Auto 
FormList Property JThrowingWeaponListNPC  Auto 
FormList Property JThrowingWeaponSpellNPC  Auto 
FormList Property JThrowingWeaponSpellHidden  Auto 

Quest property ThrowSneakTargetNPC auto

WEAPON ThrowingWeapon

SPELL ThrowingWeaponAbilityR
SPELL ThrowingWeaponAbilityRHidden
SPELL ThrowingWeaponAbilityL
SPELL ThrowingWeaponAbilityLHidden
WEAPON WeaponEquipedR
WEAPON WeaponEquipedL
WEAPON ThrowingWeaponNPC

WEAPON TempWeapon
SPELL TempSpell
SPELL TempSpellHidden

bool OnAttack

int EquippedJavelinCount = 0

int Function GetFormIndex(FormList akFormList, Form akBaseObject) global

int index = 0
	while (akFormList.GetAt(index) != akBaseObject)
		index += 1
	endwhile
	Return index

EndFunction

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)

	if !(JThrowingWeaponList.HasForm(akBaseObject))
		Return
	endif
	
		if (game.GetPlayer().GetEquippedWeapon() == akBaseObject)
			WeaponEquipedR = game.GetPlayer().GetEquippedWeapon() ;akBaseObject as Weapon
			ThrowingWeaponAbilityR = JThrowingWeaponSpell.GetAt(GetFormIndex(JThrowingWeaponList, akBaseObject)) as Spell
			ThrowingWeaponAbilityRHidden = JThrowingWeaponSpellHidden.GetAt(GetFormIndex(JThrowingWeaponList, akBaseObject)) as Spell
			RegisterForAnimationEvent(game.GetPlayer(), "WeaponSwing")
		endif

		if (game.GetPlayer().GetEquippedWeapon(true) == akBaseObject)
			WeaponEquipedL = game.GetPlayer().GetEquippedWeapon(true) ;akBaseObject as Weapon
			ThrowingWeaponAbilityL = JThrowingWeaponSpell.GetAt(GetFormIndex(JThrowingWeaponList, akBaseObject)) as Spell
			ThrowingWeaponAbilityLHidden = JThrowingWeaponSpellHidden.GetAt(GetFormIndex(JThrowingWeaponList, akBaseObject)) as Spell
			RegisterForAnimationEvent(game.GetPlayer(), "WeaponLeftSwing")
		endif
	
	EquippedJavelinCount += 1

endEvent


Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)

	if !(JThrowingWeaponList.HasForm(akBaseObject))
		Return
	endif

	if (akBaseObject == WeaponEquipedR)
		Utility.Wait(0.1)
		if !(game.GetPlayer().GetEquippedWeapon(false) == WeaponEquipedR)
			UnregisterForAnimationEvent(game.GetPlayer(), "WeaponSwing")	
			WeaponEquipedR = None	
			ThrowingWeaponAbilityR = None
			ThrowingWeaponAbilityRHidden = None
		endif
	endif

	If  (akBaseObject == WeaponEquipedL)
		Utility.Wait(0.1)
		if !(game.GetPlayer().GetEquippedWeapon(true) == WeaponEquipedL)
			UnregisterForAnimationEvent(game.GetPlayer(), "WeaponLeftSwing")
			WeaponEquipedL = None 
			ThrowingWeaponAbilityL = None	
			ThrowingWeaponAbilityLHidden = None
		endif
	endif

	EquippedJavelinCount -= 1

endEvent

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	
	if !(JThrowingWeaponListNPC.HasForm(akBaseItem))
		Return
	endif	

	game.GetPlayer().RemoveItem(akBaseItem, aiItemCount, true)		
	ThrowingWeaponNPC = JThrowingWeaponList.GetAt(GetFormIndex(JThrowingWeaponListNPC, akBaseItem)) as Weapon
	game.GetPlayer().AddItem(ThrowingWeaponNPC, aiItemCount)

endEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)

	if (OnAttack == true)
			akItemReference.delete()		

			if (akBaseItem == WeaponEquipedR)
				OnAttack = False
				WeaponEquipedR = akBaseItem as Weapon
			endif

			if (akBaseItem == WeaponEquipedL)
				OnAttack = False
				WeaponEquipedL = akBaseItem as Weapon
			endif
	endif

endEvent

Event OnDying(Actor akKiller)

	UnregisterForAnimationEvent(game.GetPlayer(), "WeaponSwing")
	UnregisterForAnimationEvent(game.GetPlayer(), "WeaponLeftSwing")
	WeaponEquipedR = None
	WeaponEquipedL = None

endEvent

Function ThrowJavelin(weapon ShootingWeapon, int Hand)

	if (Hand == 0)
		TempWeapon = WeaponEquipedR
		TempSpell = ThrowingWeaponAbilityR
		TempSpellHidden = ThrowingWeaponAbilityRHidden
	elseif (Hand == 1)
		TempWeapon =  WeaponEquipedL
		TempSpell = ThrowingWeaponAbilityL
		TempSpellHidden = ThrowingWeaponAbilityLHidden
	endif

	TempSpell.Cast(game.GetPlayer())
	QuestUpdate()
	if (TempSpellHidden != TempSpell)
		TempSpellHidden.Cast(game.GetPlayer())
	endif
		
	if (game.GetPlayer().GetItemCount(TempWeapon) == 0)
		game.GetPlayer().UnequipItem(TempWeapon, false, true)
		If (Hand == 0)
			UnregisterForAnimationEvent(game.GetPlayer(), "WeaponSwing")
			;self.DropObject(WeaponEquipedR, 1)
		elseif (Hand == 1)
			UnregisterForAnimationEvent(game.GetPlayer(), "WeaponSwing")
			;self.DropObject(WeaponEquipedL, 1)
		endif
	endif

	If (Hand == 0)
			WeaponEquipedR = ShootingWeapon
			;if !(game.GetPlayer().GetItemCount(TempWeapon) <= EquippedKnifeCount && game.GetPlayer().GetItemCount(TempWeapon) == 0)
			if !(game.GetPlayer().GetItemCount(TempWeapon) == 0)
				game.GetPlayer().EquipItem(ShootingWeapon)	
			endif		
		else	
			WeaponEquipedL = ShootingWeapon
			if !(game.GetPlayer().GetItemCount(TempWeapon) <= EquippedJavelinCount && game.GetPlayer().GetItemCount(TempWeapon) == 0)
				game.GetPlayer().EquipItem(ShootingWeapon)
			endif
	endif

	TempWeapon = None
	TempSpell = None

endFunction

Function QuestUpdate()
	ThrowSneakTargetNPC.Stop()
	ThrowSneakTargetNPC.Start()
endFunction

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	if ! (akSource == game.GetPlayer())
		return
	endif	

	if (asEventName == "WeaponSwing")
		OnAttack = true	
		game.GetPlayer().DropObject(WeaponEquipedR, 1)
		ThrowJavelin(WeaponEquipedR, 0)
	elseif (asEventName == "WeaponLeftSwing")
		OnAttack = true	
		game.GetPlayer().DropObject(WeaponEquipedL, 1)
		ThrowJavelin(WeaponEquipedL, 1)
	endif 
endEvent 
